#~*~ coding: utf-8 ~*~
# german_stem_kommz_var5.py
import string

# Das ist eine genderte Variante von dem Code unter
# http://snowball.tartarus.org/otherlangs/german_py.txt

#   Die Funktion stem nimmt ein Wort und versucht dies durch Regelanwendung zu verkrzen. Wenn Stop auf 'True' gesetzt wird, werden Wrter in der Stopliste nicht 'gestemmt'.
def stem(wort, stop = True):
	#   ACHTUNG: fr den Stemmer gilt 'y' als Vokal.
	vokale = 'aeiouy'
	#   ACHTUNG: 'U' und 'Y' gelten als Konsonaten.
	konsonanten = 'bcdfghjklmnpqrstvwxzUY'
	#   Konsonanten die vor einer 's'-Endung stehen drfen.
	s_endung = 'bdfghklmnrt'
	#   Konsonanten die vor einer 'st'-Endung stehen drfen.
	st_endung = 'bdfghklmnt'
	#   Zu r1 & r2 siehe http://snowball.tartarus.org/texts/r1r2.html, p1 & p2 sind die Start'p'ositionen von r1 & r2 im String
	r1 =''
	p1 = 0
	r2 = ''
	p2 = 0
	#   Die Stopliste; Wrter in dieser Liste werden nicht 'gestemmt', wenn stop  = 'True' an die Funktion bergeben wurde
	stopliste =['aber', 'alle', 'allem', 'allen', 'aller', 'alles', 'als',
		'also', 'am', 'an', 'ander', 'andere', 'anderem', 'anderen', 'anderer',
		'anderes', 'anderm', 'andern', 'anders', 'auch', 'auf', 'aus', 'bei',
		'bin', 'bis', 'bist', 'da', 'damit', 'dann', 'der', 'den', 'des', 'dem',
		'die', 'das', 'dass', 'da', 'derselbe', 'derselben', 'denselben',
		'desselben', 'demselben', 'dieselbe', 'dieselben', 'dasselbe', 'dazu',
		'dein', 'deine', 'deinem', 'deinen', 'deiner', 'deines', 'denn',
		'derer', 'dessen', 'dich', 'dir', 'du', 'dies', 'diese', 'diesem',
		'diesen', 'dieser', 'dieses', 'doch', 'dort', 'durch', 'ein', 'eine',
		'einem', 'einen', 'einer', 'eines', 'einig', 'einige', 'einigem',
		'einigen', 'einiger', 'einiges', 'einmal', 'er', 'ihn', 'ihm', 'es',
		'etwas', 'euer', 'eure', 'eurem', 'euren', 'eurer', 'eures', 'fr',
		'gegen', 'gewesen', 'hab', 'habe', 'haben', 'hat', 'hatte', 'hatten',
		'hier', 'hin', 'hinter', 'ich', 'mich', 'mir', 'ihr', 'ihre', 'ihrem',
		'ihren', 'ihrer', 'ihres', 'euch', 'im', 'in', 'indem', 'ins', 'ist',
		'jede', 'jedem', 'jeden', 'jeder', 'jedes', 'jene', 'jenem', 'jenen',
		'jener', 'jenes', 'jetzt', 'kann', 'kein', 'keine', 'keinem', 'keinen',
		'keiner', 'keines', 'knnen', 'knnte', 'machen', 'man', 'manche',
		'manchem', 'manchen', 'mancher', 'manches', 'mein', 'meine', 'meinem',
		'meinen', 'meiner', 'meines', 'mit', 'muss', 'musste', 'mu', 'mute',
		'nach', 'nicht', 'nichts', 'noch', 'nun', 'nur', 'ob', 'oder', 'ohne',
		'sehr', 'sein', 'seine', 'seinem', 'seinen', 'seiner', 'seines',
		'selbst', 'sich', 'sie', 'ihnen', 'sind', 'so', 'solche', 'solchem',
		'solchen', 'solcher', 'solches', 'soll', 'sollte', 'sondern', 'sonst',
		'ber', 'um', 'und', 'uns', 'unse', 'unsem', 'unsen', 'unser', 'unses',
		'unter', 'viel', 'vom', 'von', 'vor', 'whrend', 'war', 'waren',
		'warst', 'was', 'weg', 'weil', 'weiter', 'welche', 'welchem',
		'welchen', 'welcher', 'welches', 'wenn', 'werde', 'werden', 'wie',
		'wieder', 'will', 'wir', 'wird', 'wirst', 'wo', 'wollem', 'wollte',
		'wrde', 'wrden', 'zu', 'zum', 'zur', 'zwar', 'zwischen']	
	
	#   Wenn 'stop' und Wort in Stopliste gib 'wort' zurck 
	print "\n>>> VORBEREITUNG: "
	if ((stop == True) and (wort in stopliste)):
		print "\nDas Wort ist in der Stoppwortliste!"
		return wort
	else:
		pass
	
	#   Wortstmme werden klein geschrieben
	wort = wort.lower()
	print "\nDas Wort wird in Kleinschreibung \x81berf\x81hrt: \n-> ", wort

	#   Ersetze alle '' durch 'ss'
	#while '' in wort:
	while '\xe1' in wort: #nach ascii wre es 0xdf; 223
		wort = wort[:(wort.find('\xe1'))] + 'ss' + wort[((wort.find('\xe1'))+1):]
		print "\n'\xe1' wird durch 'ss' ersetzt:\n-> ", wort
	
	#   Schtzenswerte 'u' bzw. 'y' werden durch 'U' bzw. 'Y' ersetzt
	for e in map(None, wort, range(len(wort))): # Tupel (Buchstabe, Position); e[0] ist Buchstabe
		if e[1] == 0: continue # Erster Buchstabe wird unverndert gelassen
		if '\x75' in e: # if 'u' in e:		
			try:
				if ((wort[(e[1]-1)] in vokale) and (wort[(e[1]+1)] in vokale)): 
					wort = wort[:e[1]] + 'U' + wort[(e[1]+1):] # wenn sowohl vor als auch nach dem u ein Vokal kommt
					print "VuV > VUV:\n-> ", wort
			except: pass
			
		if  '\x79' in e: #if  'y' in e:
			try:
				if ((wort[(e[1]-1)] in vokale) and (wort[(e[1]+1)] in vokale)): 
					wort = wort[:e[1]] + 'Y' + wort[(e[1]+1):] # wenn sowohl vor als auch nach dem y ein Vokal kommt
					print "VyV > VYV:\n-> ", wort
			except: pass
   
   #   r1, r2, p1 & p2 werden mit Werten belegt
	try:
		Bedingung = False
		# Wort wird durchsucht
		for e in map(None, wort, range(len(wort))): # Tupel (Buchstabe, Position); e[0] ist Buchstabe
			if e[0] in vokale: 
				Bedingung = True
			if ((e[0] in konsonanten) and (Bedingung)): # wenn Buchstabe ein Kons ist, der auf ein Vokal folgt
				p1 = e[1] + 1
				r1 = wort[p1:]
				break
		Bedingung = False
		# Wort wird ab r1 durchsucht
		for e in map(None, r1, range(len(r1))): 
			if e[0] in vokale: Bedingung = True
			if ((e[0] in konsonanten) and (Bedingung)):
				p2 = e[1] + 1 
				r2 = r1[p2:]
				break
		if ((p1 < 3)and(p1 > 0)): # vor r1 mssen mind. 3 Buchstaben stehen
			p1 = 3
			r1 = wort[p1:]
		if p1 == 0: # Wort wird nicht bearbeitet
			print "\n>>> BEARBEITUNG: "
			print "(Keine Bearbeitung m\x94glich.)"
			return (end_stemming(wort))
	except: pass

#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
	
	#   Die Schritte 1 bis 3 d) 'stemmen' das bergebene Wort. 
	print "\n>>> BEARBEITUNG: "
	bb = 0 # Zhler berprft, ob etwas in der Bearbeitungsphase passiert
	#   Schritt 1
	eSuffixe_1 = ['e', 'em', 'en', 'ern', 'er', 'es']
	eSonst_1 = ['s']
	try:
		for e in eSuffixe_1:
			if e in r1[-(len(e)):]:
				wort = wort[:-(len(e))]
				bb = 1
				print "\nSchritt 1/1: 'e' / 'em' / 'en' / 'ern' / 'er' / 'es' werden entfernt.\n-> ", wort
				r1 = r1[:-(len(e))]
				r2 = r2[:-(len(e))]
				break
		else:
			if r1[-1] in eSonst_1:
				if wort[-2] in s_endung:
					wort = wort[:-1]
					bb = 1
					print "\nSchritt 1/2: 's' wird entfernt.\n-> ", wort
					r1 = r1[:-1]
					r2 = r2[:-1]
	except: pass
	
	#   Schritt 2
	eSuffixe_2 = ['est', 'er', 'en']
	eSonst_2 = ['st']
	try:
		for e in eSuffixe_2:
			if e in r1[-len(e):]:
				wort = wort[:-len(e)]
				bb = 1
				print "\nSchritt 2/1: 'est' / 'er' / 'en' werden entfernt.\n-> ", wort

				r1 = r1[:-len(e)]
				r2 = r2[:-len(e)]
				break
		else:
			if r1[-2:] in eSonst_2:
				if wort[-3] in st_endung:
					if len(wort) > 5:
						wort = wort[:-2]
						bb = 1
						print "\nSchritt 2/2: 'st' wird entfernt.\n-> ", wort
						r1 = r1[:-2]
						r2 = r2[:-2]
	except:pass

	#   Schritt 3 a)
	dSuffixe_1 = ['end', 'ung']
	try:
		for e in dSuffixe_1:
			if e in r2[-(len(e)):]:
				if 'ig' in r2[-(len(e)+2):-(len(e))]:
					if 'e' in wort[-(len(e)+3)]:
						wort = wort[:-(len(e))]
						bb = 1
						#?#print "\nSchritt 3a/21: 'end' / 'ung' wird entfernt.\n-> ", wort
						r1 = r1[:-(len(e))]
						r2 = r2[:-(len(e))]
						break
					else:
						wort = wort[:-(len(e)+2)]
						bb = 1
						print "\nSchritt 3a/1: 'igend' / 'igung' wird entfernt.\n-> ", wort
						r2 = r2[:-(len(e)+2)]
						r1 = r1[:-(len(e)+2)]
						break
				else:
					wort = wort[:-(len(e))]
					bb = 1
					print "\nSchritt 3a/2: 'end' / 'ung' werden entfernt.\n-> ", wort
					r2 = r2[:-(len(e))]
					r1 = r1[:-(len(e))]
				return (end_stemming(wort))
	except: pass
	
	#   Schritt 3 b)
	dSuffixe_2 = ['ig', 'ik', 'isch']
	try:
		for e in dSuffixe_2:
			if e in r2[-(len(e)):]:
				if (('e' in wort[-(len(e)+1)])):
					pass
				else:
					wort = wort[:-(len(e))]
					bb = 1
					print "\nSchritt 3b: 'ig' / 'ik' / 'isch' werden entfernt.\n-> ", wort
					r2 = r2[:-(len(e))]
					r1 = r1[:-(len(e))]
					break
	except: pass

	#   Schritt 3 c)
	dSuffixe_3 = ['lich', 'heit']
	sonder_1 = ['er', 'en']
	try: 
		for e in dSuffixe_3:
			if e in r2[-(len(e)):]:
				for i in sonder_1:
					if i in r1[-(len(e)+len(i)):-(len(e))]:
						wort = wort[:-(len(e)+len(i))]
						bb = 1
						print "\nSchritt 3c: 'erlich' / 'enlich' / 'erheit' / 'enheit' werden entfernt.\n-> ", wort
						r1 = r1[:-(len(e)+len(i))]
						r2 = r2[:-(len(e)+len(i))]
						break
				else:
					wort = wort[:-(len(e))]
					bb = 1
					print "\nSchritt 3c: 'lich' / 'heit' werden entfernt.\n-> ", wort
					r1 = r1[:-(len(e))]
					r2 = r2[:-(len(e))]
					break
	except: pass
	
	#   Schritt 3 d)
	dSuffixe_4 = ['keit']
	sonder_2 = ['lich', 'ig']
	try:
		for e in dSuffixe_4:
			if e in r2[-(len(e)):]:
				for i in sonder_2:
					if i in r2[-(len(e)+len(i)):-(len(e))]:
						wort = wort[:-(len(e)+len(i))]
						bb = 1
						print "\nSchritt 3d/1: 'lichkeit' / 'igkeit' werden entfernt.\n-> ", wort
						break
				else:
					wort = wort[:-(len(e))]
					bb = 1
					print "\nSchritt 3d/2: 'keit' wird entfernt.\n-> ", wort
	except: pass
	if bb == 0:
		print "(Keine Bearbeitung m\x94glich.)"
	return(end_stemming(wort))

#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#

#   end_stemming verwandelt '', '', '' in den "Grundvokal" und macht 'U' bzw. 'Y' klein. 
def end_stemming(wort):
	print "\n>>> NACHBEREITUNG:"
	nb = 0 # Zhler berprft, ob etwas in der Nachbereitungsphase passiert
	while '\x84' in wort: #
		wort = wort[:(wort.find('\x84'))] + 'a' + wort[((wort.find('\x84'))+1):]
		nb = 1
		print "-> '\x84' > 'a'"
	while '\x94' in wort: #
		wort = wort[:(wort.find('\x94'))] + 'o' + wort[((wort.find('\x94'))+1):]
		nb = 1
		print "-> '\x94' > 'o'"	
	while '\x81' in wort: #
		wort = wort[:(wort.find('\x81'))] + 'u' + wort[((wort.find('\x81'))+1):]
		nb = 1
		print "-> '\x81' > 'u'"
	while 'U' in wort: #U == \x55
		wort = wort[:(wort.find('U'))] + 'u' + wort[((wort.find('U'))+1):]
		nb = 1
		print "-> 'U' > 'u'"
	while 'Y' in wort: #Y == \x59
		wort = wort[:(wort.find('Y'))] + 'y' + wort[((wort.find('Y'))+1):]
		nb = 1
		print "-> 'Y' > 'y'"
	if nb == 0:
		print "(Keine Nachbereitung n\x94tig.)"

	print "\n>>> AUSGABE:\n=> Der Stamm des Wortes = ", wort
	return wort

def wortformEinlesen():
	print ">>> EINGABE: "
	x = raw_input()
	return x

def regelZeigen():
	f = open("Regeln.txt")
	for i in f.readlines():
		print i
	f.close()

if __name__=="__main__":
	print "\n\t* * * Das ist ein Porter-Stemmer f\x81r das Deutsche. * * *\n"
	antwort = "j"
	while (antwort == "j"):
		print "\n", 78*"~", "\n"  
		eingabe = wortformEinlesen()
		stem(eingabe)
		print "\n", 39*"~ "
		print "\n>>> Weitere Stammermittlungen? (j/n/r)\n\tj=ja, n=nein, r=Regeln zeigen"
		antwort = raw_input()
		if antwort == "r":
			print "\n"
			regelZeigen()
			print "\n", 78*"~"
			print "\n>>> Weitere Stammermittlungen? (j/n)\n\tj=ja, n=nein"
			antwort = raw_input()
